DECLARE SUB icon17 (file$, xpos%, ypos%, nocolor%)
DEFINT A-Z
DECLARE SUB clearwindow (start.l%, col%, ecol%, lines%, clr%)
DECLARE SUB mouse (Funcode%, result%, P2%, p3%, p4%)
DECLARE SUB icon4 (file$, xpos%, ypos%)
DECLARE SUB colrprnt (TEXT$, Row%, col%, FC%, BC%)
DECLARE SUB icon16 (file$, xpos%, ypos%)
'AUTHOR Fred Buffington
'<c> January 1999. All rights reserved.
'Quick Basic, Qbasic. Quick Basic code. Requires QB.QLB be loaded.
'Has not been tested on PB but should work ok with the usual adjustments.
'Freeware. Install Shell. Modify packing.lst with your programs/file names.
'change the icon (766 byte icon). and/or change the "Client Writeup"
'references to your own. Actual Copy will need to be enabled as well
'as any other installation procedures you need to do. A sample unzip
'line is included but is remmed out for the demo. With your "copy"
'procedure enabled you should rem out or remove the "timer" used
'in the copy routine section unless you need to slow down the program
'which is why I used it, since there was no actual copy being done
'in this demo.
'WHEN THE COPY WINDOW DISPLAYS (WITH THE PERCENTAGE), TRY CLICKING THE
'UNDERLINE CHARACTER _ TO 'HIDE' THE WINDOW. SHOWS ICON AND PERCENTAGE
'ON BOTTOM TASK BAR. submitted to Qlympics 99.
'ICON16 prints approxamately the 1st 16 lines of an icon and the middle
'16 bytes of those lines resulting in a 16x16 display rather than a
'32x32 display. If you use this, remember that the icon should have the
'most significant feature of the icon within this area.

 TYPE regtype
   ax AS INTEGER
   bx AS INTEGER
   cx AS INTEGER
   dx AS INTEGER
   bp AS INTEGER
   si AS INTEGER
   di AS INTEGER
   flags AS INTEGER
   ds AS INTEGER
   es AS INTEGER
 END TYPE

 DIM regs AS regtype

TYPE regtypeX
     ax    AS INTEGER
     bx    AS INTEGER
     cx    AS INTEGER
     dx    AS INTEGER
     bp    AS INTEGER
     si    AS INTEGER
     di    AS INTEGER
     flags AS INTEGER
     ds    AS INTEGER
     es    AS INTEGER
END TYPE
 DIM INReg AS regtypeX
 DIM OUTReg AS regtypeX
'mouse interrupt variables
CONST SetCursor = 9
CONST ShowCur = 1
CONST HideCur = 2
CONST MInit = 0
CONST MStatus = 3
ON ERROR GOTO error.routine

init:
    cm$ = "Y"
    message% = 1
screen.display:
    SCREEN 12
    WIDTH 80, 60
    W% = 0: x% = 0: y% = 639: z% = 479
    VIEW SCREEN (W%, x%)-(y%, z%), 0, 15    'define a viewport w/ border
'grey screen
    
    red% = 38: green% = 46: blue% = 52
    A& = (65536 * blue%) + (256 * green%) + red%   'calc the new palette
   
    PALETTE 1, A&   'display the new palette
    LOCATE 3, 28: PRINT "     "    'update the screen data
    LINE (0, 17)-(639, 479), 1, BF ',130
    DRAW "BM 35,21 C0"

'initialize mouse and show it
    mouse MInit, amouse%, 0, 0, 0:    'Initialize mouse driver
    IF amouse% THEN
       mouse 1, MOUSEBUTTON, xpos%, ypos%, 255
       mouse 4, 0, MOUSEBUTTON, 380, 100 '120
       mouse ShowCur, 0, MOUSEBUTTON, mouseX, mouseY
    END IF

'display intro message
    GOSUB help
'clear the screen to blue-gray
    LINE (0, 131)-(639, 479), 1, BF
    'LINE (0, 35)-(639, 454), 15, BF
    LINE (0, 34)-(639, 449), 3, BF
''line at bottom
    LINE (0, 451)-(639, 451), 0
    LINE (0, 450)-(639, 450), 15
    clr1% = 15: clr2% = 8
'TOP 1 colr of 2 for top
'input area for path
'heading
    FG% = 15: BG% = 3: Row% = 2: col% = 5
    colrprnt SPACE$(76), 1, 5, FG%, BG%
    colrprnt SPACE$(76), 2, 5, FG%, BG%

'box around path input
    LINE (11, 61)-(628, 116), 1, BF
    LINE (10, 60)-(629, 116), 0, B
    'WHILE INKEY$ = "": WEND
    LINE (9, 59)-(630, 117), 15, B''8, B
    
'prompt for path input
    LINE (464, 68)-(624, 81), 15, BF
    st$ = "Enter folder(path) for installation (<Enter>=C:\oasys>)"
    Row% = 5: col% = 3: BG% = 1: FG% = 15
    Row% = 10: col% = 3: BG% = 1: FG% = 15
    colrprnt st$, Row%, col%, FG%, BG%
    'ST$ = "(Esc=Abort installation)"

'path input cancel and install buttons
    st$ = "Cancel"
    colrprnt st$, Row% + 4, 28, 0, BG%
   
    LINE (210, 100)-(264, 100), 15
    LINE (210, 100)-(210, 112), 15
    LINE (210, 112)-(264, 112), 0
    LINE (210, 113)-(264, 113), 0
    LINE (264, 100)-(264, 112), 0
    LINE (265, 100)-(265, 112), 0
   
    st$ = " Next "
    colrprnt st$, Row% + 4, 40, 0, BG%
    LINE (306, 100)-(368, 100), 15
    LINE (306, 100)-(306, 112), 15
    LINE (306, 112)-(368, 112), 0
    LINE (306, 113)-(368, 113), 0
    LINE (368, 100)-(368, 112), 0
    LINE (369, 100)-(369, 112), 0

'change color of top slightly
    FOR k = 0 TO 624 STEP 2
         LINE (k, 0)-(k + 15, 16), 1'14
    NEXT k
    FOR k = 626 TO 640 STEP 2
        LINE (k, 0)-(k + (640 - k), 640 - k), 3'14
    NEXT k
    LINE (0, 0)-(639, 0), 15
    LINE (0, 18)-(639, 18), 15
    LINE (0, 33)-(639, 33), 0


'try new font with "client"
    DRAW "BM 40,4 C14"
      bmsg$ = "Client Writeup"
      FOR k = 1 TO LEN(bmsg$)
       char$ = MID$(bmsg$, k, 1)
       GOSUB seven.by.five
      NEXT k
    DRAW "BM 41,5 C0"
      bmsg$ = "Client Writeup"
      FOR k = 1 TO LEN(bmsg$)
       char$ = MID$(bmsg$, k, 1)
       GOSUB seven.by.five
      NEXT k
 

'put fake buttons on  (_ O X) actually X will be functional

'button 1
    x1% = 593: y1% = 3
    GOSUB do.buttons 'does all 3
    FOR k = 597 TO 602 STEP 2
        PSET (k, 11), 1
    NEXT
'button 2
'button 3

'display icon
    icon4 "qb45b.ico", 0, 31 'will work with most 32x32 16 color icons

'icon5 prints an icon (766 byte file 4 times the size (64x64)
   '' icon5 "wumenu1.ico", 10, 200 'will work with most 32x32 16 color icons
'allow user to change path
    Row% = 10: col% = 59
    x$ = ""
    st$ = ""
    IF amouse% THEN mouse 4, 0, MOUSEBUTTON, 320, 128
'print message at bottom in small font
    bmsg$ = "Press <Enter> for Default or type dos path"
    bmsg$ = UCASE$(bmsg$)
    DRAW "BM 208,470 C15"
    FOR kkk = 1 TO LEN(bmsg$)
        char$ = MID$(bmsg$, kkk, 1)
        GOSUB print.msg
    NEXT
'make fake windows start button
   icon17 "win45a.ico", 6, 490, 15 ''prints the first 16 x 16 pixels and excludes a color
   bmsg$ = "Start"
'make fake windows start button
   DRAW "BM 27,462 C0"
   DRAW "BR1 R2 D1 R2 BL5 D2 U2 R1 D3 R3 D2 U1 R1 D2 L1 D1 L3 U1 L1 BU8 BR7" 'S'
   DRAW "BR1 BD1 D7 R1 D1  U7 D2 R1 L3 R2 D5 R1 BR2 BU9" 't'
   DRAW "BD6 D2 R1 D1 U3 R4 D3 L4 R3 U5 L3 BU3 BR6" 'a'
   DRAW "BD3 D5 R1 U5 R1 BR2 BU4" 'r'
   DRAW "BR1 BD1 D7 R1 D1  U7 D2 R1 L3 R2 D5 R1 BR1 BU9" 't'
    LINE (2, 456)-(58, 477), 0, B
    LINE (2, 476)-(58, 476), 0
    LINE (59, 456)-(59, 477), 0
    LINE (2, 455)-(57, 455), 15
    LINE (2, 456)-(57, 456), 1
    FOR k% = 3 TO 55 STEP 2
        PSET (k%, 455), 1
    NEXT k%
    tm$ = TIME$
    l% = INSTR(tm$, ":"): tz$ = RIGHT$(" " + MID$(tm$, 1, l% - 1), 2) + MID$(tm$, l%, 3): tm$ = tz$
    IF MID$(tm$, 3, 1) = ":" AND VAL(MID$(tm$, 1, 2)) > 12 THEN
        tx$ = STR$(VAL(MID$(tm$, 1, 2)) - 12) + MID$(tm$, 3, 3) + "PM"
    ELSE
        tx$ = tm$ + "AM"
    END IF
    'LOCATE 25, 70: PRINT Tx$;
    IF prior.tx$ <> tx$ THEN colrprnt tx$, 59, 71, 0, 1
    prior.tx$ = tx$
get.path:
    DO
        WHILE x$ = "":
            x$ = INKEY$
            IF amouse% THEN
               mouse MStatus, 0, MOUSEBUTTON, mouseX, mouseY
               IF MOUSEBUTTON THEN
                     IF mouseX >= 625 AND mouseX <= 633 AND mouseY >= 4 AND mouseY <= 12 THEN
                         x$ = CHR$(27)
                     ELSEIF mouseX > 464 AND mouseX < 624 AND mouseY > 62 AND mouseY < 80 THEN
                         LINE (466, 69)-(466, 80), 0
                     ELSEIF mouseX >= 210 AND mouseX <= 264 AND mouseY >= 100 AND mouseY <= 112 THEN
                         x$ = CHR$(27)
                         mouse 4, 0, MOUSEBUTTON, 320, 153
                         mouse ShowCur, 0, MOUSEBUTTON, mouseX, mouseY
                         LINE (210, 101)-(264, 101), 0
                         LINE (211, 101)-(211, 111), 0
                         LINE (210, 112)-(264, 112), 15
                         LINE (264, 100)-(264, 112), 15
                     ELSEIF mouseX >= 306 AND mouseX <= 368 AND mouseY >= 100 AND mouseY <= 112 THEN
                          x$ = CHR$(13)
                     ELSE
                         x$ = CHR$(13)
                     END IF
               END IF
            END IF
            tm$ = TIME$
            l% = INSTR(tm$, ":"): tz$ = RIGHT$(" " + MID$(tm$, 1, l% - 1), 2) + MID$(tm$, l%, 3): tm$ = tz$
            IF MID$(tm$, 3, 1) = ":" AND VAL(MID$(tm$, 1, 2)) > 12 THEN
                tx$ = STR$(VAL(MID$(tm$, 1, 2)) - 12) + MID$(tm$, 3, 3) + "PM"
            ELSE
                tx$ = tm$ + "AM"
            END IF
    
            IF prior.tx$ <> tx$ THEN colrprnt tx$, 59, 71, 0, 1
            prior.tx$ = tx$
        WEND
        IF ASC(x$) = 8 THEN
            IF LEN(st$) > 1 THEN
                xst$ = MID$(st$, 1, LEN(st$) - 1): st$ = xst$
            ELSE
                st$ = ""
            END IF
            col% = col% - 1
            IF col% < 59 THEN col% = 59
            LINE (464, 68)-(624, 81), 15, BF
           
            IF st$ > "" THEN colrprnt st$, Row%, 59, 0, 15
        END IF
        IF ASC(x$) > 28 THEN
            LINE (464, 68)-(624, 81), 15, BF
            'colrprnt x$, Row%, col%, 0, 15''FG%, BG%
            col% = col% + 1
            st$ = st$ + x$
            colrprnt st$, Row%, 59, 0, 15''FG%, BG%
            x$ = ""
        END IF
        IF x$ = CHR$(27) THEN abort% = -1: EXIT DO
        IF x$ <> CHR$(13) THEN x$ = ""
   
    LOOP WHILE x$ <> CHR$(13)

'path inputed so check for abort response
    IF abort% THEN
        colrprnt "Install Aborted !", 18, 31, 0, 1
        SLEEP 2
        CLOSE
        SCREEN 2: SCREEN 0
        END
    END IF

'remove message at bottom
    LINE (200, 470)-(440, 477), 1, BF
    IF amouse% THEN mouse 4, 0, MOUSEBUTTON, 320, 120
'set and print path if user presses enter - change to path wanted (default)
    'IF ST$ = "" THEN ST$ = "C:\oasys": Row% = 5: col% = 59: colrprnt "C:\oasys", Row%, col%, 0, 15
    IF st$ = "" THEN st$ = "C:\oasys": Row% = 10: col% = 59: colrprnt "C:\oasys", Row%, col%, 0, 15
    fpth$ = st$

'check folder entry - limit to 8 characters
    l% = INSTR(fpth$, "\")
    IF l% = 0 THEN l% = 1
    WHILE l% > 0
        m% = INSTR(l% + 1, fpth$, "\")
        IF m% = 0 AND l% > 0 THEN m% = LEN(fpth$) + 1
        IF l% = 1 AND MID$(fpth$ + SPACE$(1), 1, 1) <> "\" THEN l% = 0
        IF m% - l% - 1 > 8 THEN
            BEEP: st$ = "": fpth$ = "": x$ = ""
            col% = 59
            LINE (464, 70)-(624, 79), 15, BF
            LINE (466, 71)-(466, 78), 0
            GOTO get.path
        END IF
        IF m% > l% AND l% > 0 THEN l% = m%: m% = 0 ELSE l% = 0: m% = 0
    WEND

'remove input box
    LINE (9, 59)-(630, 117), 3, BF
'X at top no loner valid
    'LINE (626, 11)-(632, 5), 0
    LINE (627, 11)-(633, 5), 1
    LINE (627, 5)-(633, 11), 1


'copy routine 'show gray box
    IF amouse% THEN mouse 4, 0, MOUSEBUTTON, 320, 100
    GOSUB copy.box
    Row% = 17: col% = 30
    Row% = 34: col% = 30

'packing list containing names of files. change for your list of files.
    OPEN "packing.lst" FOR INPUT AS #5

'get file name  and display it on screen
'''SHELL "md "+fpth$ '
    DO
        LINE INPUT #5, ff$ 'get the name of the file from the packing list
        IF hidden% = 0 THEN colrprnt ff$ + SPACE$(10), Row%, col%, 0, 15
    tm$ = TIME$
    l% = INSTR(tm$, ":"): tz$ = RIGHT$(" " + MID$(tm$, 1, l% - 1), 2) + MID$(tm$, l%, 3): tm$ = tz$
    IF MID$(tm$, 3, 1) = ":" AND VAL(MID$(tm$, 1, 2)) > 12 THEN
        tx$ = STR$(VAL(MID$(tm$, 1, 2)) - 12) + MID$(tm$, 3, 3) + "PM"
    ELSE
        tx$ = tm$ + "AM"
    END IF
    IF prior.tx$ <> tx$ THEN colrprnt tx$, 59, 71, 0, 1
    prior.tx$ = tx$

'your routine here and remove sleep if necessary
'typical install routine example. change zip file name, set fpth$, etc

'''SHELL "PKUNZIP >nul -- -+ -o " + "oas.ZIP " + MID$(ff$, 1, 12) + " " + fpth$
'using >nul keeps pkzip from printing a message on the screen
'you could also have the file sizes in the program and use the total of the
'file sizes as a denominator. then count% =count%+1 would be changed to
'count%=count%+file.size. You may want to use count& instead.
       mouse MStatus, 0, MOUSEBUTTON, mouseX, mouseY
       IF MOUSEBUTTON THEN
          IF hidden% THEN GOSUB check.hidden ELSE GOSUB check.not.hidden
       END IF
       'IF hidden% THEN GOSUB check.hidden ELSE GOSUB check.not.hidden
        count% = count% + 1
      
        pct% = count% / 50 * 100 'change this (50) for actual count
      
        mouse MStatus, 0, MOUSEBUTTON, mouseX, mouseY
       IF MOUSEBUTTON THEN
          IF hidden% THEN GOSUB check.hidden ELSE GOSUB check.not.hidden
       END IF
      
       IF hidden% = 0 THEN
        IF pct% / 2 = INT(pct% / 2) THEN
            'colrprnt SPACE$(pct% / 2), 19, 16, 7, 8
            'colrprnt SPACE$(50), 38, 16, 7, 15
            IF pct% < 45 THEN
                LINE (312, 290)-(340, 300), 15, BF
            ELSEIF pct% > 60 THEN
                LINE (312, 290)-(340, 300), 3, BF
            END IF
            colrprnt SPACE$(pct% / 2), 38, 16, 7, 3
            mouse MStatus, 0, MOUSEBUTTON, mouseX, mouseY
            IF MOUSEBUTTON THEN
                IF hidden% THEN GOSUB check.hidden ELSE GOSUB check.not.hidden
            END IF
           
            IF hidden% = 0 THEN colrprnt SPACE$(pct% / 2), 37, 16, 7, 3
              bmsg$ = LTRIM$(STR$(pct%)) + "%"
              IF hidden% = 0 THEN
                DRAW "BM 312,293 C0"
                FOR k = 1 TO LEN(bmsg$)
                  char$ = MID$(bmsg$, k, 1)
                  mouse MStatus, 0, MOUSEBUTTON, mouseX, mouseY
                  IF MOUSEBUTTON THEN
                    IF hidden% THEN GOSUB check.hidden ELSE GOSUB check.not.hidden
                  END IF
                  GOSUB print.msg
                NEXT
              END IF
            END IF
        END IF
      'IF hidden% THEN GOSUB check.hidden ELSE GOSUB check.not.hidden
        IF pct% / 10 = INT(pct% / 10) THEN
          GOSUB Print.Personal.Message
        END IF
        mouse MStatus, 0, MOUSEBUTTON, mouseX, mouseY
       IF MOUSEBUTTON THEN
          IF hidden% THEN GOSUB check.hidden ELSE GOSUB check.not.hidden
       END IF
       
        IF hidden% THEN GOSUB check.hidden 'ELSE GOSUB check.not.hidden
'SLEEP 1 'remove this for actual install unless you need to slow it.
'the sleep was changed to the routine below to enable the mouse to respond
'quickly.
        st$ = RIGHT$(TIME$, 2)
        DO
            mouse MStatus, 0, MOUSEBUTTON, mouseX, mouseY
            IF MOUSEBUTTON THEN
               IF hidden% THEN GOSUB check.hidden ELSE GOSUB check.not.hidden
            END IF
            IF VAL(RIGHT$(TIME$, 2)) - VAL(st$) < 0 THEN EXIT DO
        LOOP WHILE VAL(RIGHT$(TIME$, 2)) - VAL(st$) < 1

        IF count = 50 THEN EXIT DO  'for testing only - remove or modify
        dum$ = INKEY$'in case a key is hit
    LOOP WHILE NOT EOF(5)

'install's copy routine done
'insert other routines here. For instance, you may have a serial number
'routine or something else. You should also update the "task" list if
'you do something additional.

'complete message
    CLOSE #5
    IF hidden% = 0 THEN
        bmsg$ = "INSTALLATION COMPLETE"
        DRAW "BM 104,362 C0"
        FOR kkk = 1 TO LEN(bmsg$)
            char$ = MID$(bmsg$, kkk, 1)
            GOSUB print.msg
        NEXT
    
    ELSE
        st$ = "Installation Complete !!"
        col% = (80 - LEN(st$)) / 2
        IF amouse% THEN
            mouse MStatus, 0, MOUSEBUTTON, mouseX, mouseY
            IF mouseX >= 280 AND mouseX < 371 AND mouseY > 339 AND mouseY < 379 THEN
                mouse 4, 0, MOUSEBUTTON, 344, 359
            END IF
        END IF
        colrprnt st$, 50, col%, 15, 1
    END IF

'box for "OK" message to end install
    LINE (304, 354)-(366, 370), 1, BF
    LINE (304, 354)-(366, 370), 0, B
    LINE (305, 355)-(365, 369), 0, B
    LINE (304, 354)-(366, 354), 15
    LINE (304, 354)-(304, 369), 15
    colrprnt "Finish", 46, 40, 0, 1

'update the task bar if box is not hidden
    IF hidden% = 0 THEN
        LINE (100, 350)-(228, 361), 15, BF
        bmsg$ = "COPYING COMPLETE"
        DRAW "BM 104,354 C0"
        FOR kkk = 1 TO LEN(bmsg$)
            char$ = MID$(bmsg$, kkk, 1)
            GOSUB print.msg
        NEXT
    END IF

'wait for response to end the program
    DO
       mouse MStatus, 0, MOUSEBUTTON, mouseX, mouseY
       IF MOUSEBUTTON THEN
           IF mouseX > 300 AND mouseX < 370 THEN
              IF mouseY > 350 AND mouseY < 368 THEN
                  colrprnt "Finish", 46, 40, 0, 7
                  EXIT DO
              END IF
           END IF
       END IF
    LOOP WHILE INKEY$ = ""
   
    SCREEN 2: SCREEN 0
    COLOR 15, 1: CLS
    END

help:
'This is more informational than help. You can change this to print an
'actual help message or rem out the gosub help above
'box for help display
    LINE (160, 176)-(496, 268), 7, BF
    LINE (160, 175)-(496, 175), 15
    LINE (160, 176)-(160, 268), 15
    LINE (160, 268)-(496, 268), 0
    LINE (496, 176)-(496, 268), 0
    FC% = 0: BC% = 7: col% = 22
'text for help display
    colrprnt "This is a demonstration install routine.", 24, 22, 0, 7
    colrprnt "No installation is done but the program", 25, col%, FC%, BC%
    colrprnt "can be modified to use for your progs. ", 26, col%, FC%, BC%
    colrprnt "Insert a copy routine in the place shown", 27, col%, FC%, BC%
    colrprnt "and change the icon if you wish as well", 28, col%, FC%, BC%
    colrprnt "and the client writeup install at the top", 29, col%, FC%, BC%
    colrprnt "The X at the top right is clickable to ", 30, col%, FC%, BC%
    colrprnt "abort (or ESC key) until the 'fake' copy", 31, col%, FC%, BC%
    colrprnt "begins. You can " + CHR$(34) + "hide" + CHR$(34) + " the copy routine", 32, col%, FC%, BC%
    colrprnt "too !! Press any key to begin", 33, col%, FC%, BC%
    WHILE INKEY$ = "": WEND
    FOR k = 1 TO 10: x$ = INKEY$: NEXT'in case to avoid starting routine without allowing user input
    RETURN

print.msg:
SELECT CASE char$
    CASE "B"
        DRAW "D5 R3 E1 U1 H1 L1 R1 E1 U1 L4 BR6"
    CASE "H"
        DRAW "D5 BR3 U5 BD2 L3 U2 BR5"
    CASE "V"
        DRAW "D3 F2 E2 U3 BR2"
    CASE "J"
        DRAW "BD4 D1 R3 U5 BR2"

    CASE "P"
        DRAW "R3 D2 L3 U2 D5 U5 BR5"
    CASE "R"
        DRAW "R3 F1 G1 L3 U2 D5 U3 BR1 F3 BU5 BR2"
    CASE "E"
        DRAW "R3 L3 D2 R2 L2 D3 R3 L3 U5"
        DRAW "BM+5,0"
    CASE "S"
        DRAW "BR1 R3 L3 G1 F1 R2 F1 D1 G1 L3 BU5 BR6"
    CASE "A"
        DRAW "D5 U5 R4 D5 U3 L4 U2 BR6"
    CASE "N"
        DRAW "D1 F3 D1 U5 BL3 D5 BU5 BR5"
    CASE "Y"
        DRAW "F2 D3 U3 E2 Br2" ''"D2 R2 U2 D2 L1 D3 BL1 BU5"
    CASE "K"
        DRAW "D5 U2 R1 E3 G2 F3 BU5 BR2"
    CASE "T"
        DRAW "R4 L2 D5 U5"
        DRAW "BM+4,+0"
    CASE "O"
        DRAW "R3 D5 L3 U5"
        DRAW "BM+5,+0"
    CASE "X"
        DRAW "D1 F3 D1 BU5 D1 G3 D1 BU5 BR2"
        DRAW "BM+4,0"
    CASE "i"
        DRAW "BR1 D5 U5 BL1"
        DRAW "BM+4,0"
    CASE " "
        DRAW "BM+4,+0"
    CASE "L"
        DRAW "D5 R4 BU5 BR2"
    CASE "F"
        DRAW "R4 L4 D5 U3 R2 BR2 BU2 BR1"
    CASE "D"
        DRAW "D5 R2 E1 R1 U3 L1 H1 L2 BR6"
    CASE "I"
        DRAW "BR1 D5 U5 BR3"
    CASE "G"
        DRAW "BD1 D3 F1 R2 E1 U1 L1 BU3 BR1 L3 BR5"
    CASE "U"
        DRAW "D5 R4 U5 BR2"
    CASE "C"
        DRAW "BR1 R3 BL4 BD1 D3 F1 R3 BR2 BU5"
    CASE "."
        DRAW "BD5 BR2 R1 BR2 BU5"
    CASE "M"
        DRAW "D5 U5 F2 E2 D5 U5 BR2"
    CASE "0"
        DRAW "BD1 D3 F1 R2 E1 U3 H1 L2 G1 BU1 BR6"
    CASE "W"
        DRAW "D5 E2 F2 U5 BR2" ''"D3 F2 E2 F2 E2 U3 BR2"
    CASE "1"
        DRAW "BR1 D5 U5 BR3"
    CASE "2"
        DRAW "BD1 E1 R2 F1 D2 L1 G1 L1 G1 R4 BU5 BR2"
    CASE "3"
        DRAW "R3 G2 L1 R2 F1 D1 G1 L2 BU5 BR5"
    CASE "4"
        DRAW "D3 R3 D2 U5 BR2"
    CASE "5"
        DRAW "R3 L3 D2 R2 F1 D1 G1 L3 BU5 BR6"
    CASE "6"
        DRAW "BR1 G1 D3 F1 R2 E1 U1 H1 L2 BU2 BR5"
    CASE "7"
        DRAW "R4 G3 D2 BU5 BR5"
    CASE "8"
        DRAW "BR1 R2 F1 G1 L2 H1 E1 BL1 BD2 BR1 G1 D1 F1 R2 E1 U1 H1 BU2 BR3"
    CASE "9"
        DRAW "BR1 R2 F1 D1 G1 L2 H1 U1 BU1 BR4 D5 BU5 BR2"
    CASE "$"
        DRAW "BR1 R2 F1 H1 L1 D6 U7 BD1 L1 G1 F1 R2 F1 D1 G1 L2 H1 BU4 BR6"
    CASE ">"
        DRAW "F3 G3 BR5 BU6"
    CASE "<"
        DRAW "BR3 G3 F3 BU6 BR2"
    CASE "\"
         DRAW "F5 BU5 BR1"
    CASE ":"
         DRAW "BR1 BD1 D1 BD1 D1 BU4 BR1"
    CASE "%"
         DRAW "BR1 D2 R1 U1 BR3 G5 BR4 R1 U1 L1 BR2 BU4"
END SELECT
RETURN

Print.Personal.Message:
    IF amouse% THEN
        mouse MStatus, 0, MOUSEBUTTON, mouseX, mouseY
        IF mouseX >= 190 AND mouseX <= 480 AND mouseY >= 75 AND mouseY <= 159 THEN
            mouse 4, 0, MOUSEBUTTON, 320, 170
        END IF
        mouse ShowCur, 0, MOUSEBUTTON, mouseX, mouseY
    END IF
    mouse ShowCur, 0, MOUSEBUTTON, mouseX, mouseY
    message% = message% * -1
    IF message% = -1 THEN
        LINE (182, 70)-(470, 130), 3, BF
        colrprnt "Thanks for using our software.", 10, 25, 0, 3
        
        colrprnt "If you have any questions, you", 11, 25, 0, 3
       
        colrprnt "can contact us at oasys@nstar.net.", 12, 24, 0, 3
   
    ELSE
        LINE (182, 70)-(470, 130), 3, BF
        colrprnt "This is a demonstrastion of an", 10, 25, 0, 3
        
        colrprnt "Installation routine. No files", 11, 25, 0, 3
       
        colrprnt "are actually copied. You can put", 12, 24, 0, 3
       
        colrprnt "any applicable lines you need.", 13, 25, 0, 3
   
    END IF
    RETURN

error.routine:
     RESUME 0

seven.by.five:
     SELECT CASE char$
       CASE "F"
          DRAW "R4 L4 D7 U3 R3 BR4 BU4"
       CASE "a"
          DRAW "BD4 R3 F1 D2 L3 U1 E1 BU5 BR5"
       CASE "i"
          DRAW "D1 BD3 D3 BR4 BU7"
       CASE "l"
          DRAW "D7 U7 BR3"
       CASE "e"
          DRAW "BD4 R2 L2 D2 F1 R1 E1 BU2 H1 L2 BU3 BR6"
       CASE "C"
          DRAW "BR1 R3 F1 BL4 D5 F1 R3 E1 BR3 BU6"
       CASE "n"
          DRAW "BD4 D3 U3 E1 R2 F1 D3 BR3 BU7"
       CASE "t"
          DRAW "BR2 BD2 D5 R1 L1 U3 L2 R5 BR2 BU4"
       CASE ":"
          DRAW "BR1 BD2 D1 BD2 D1 BU6 BR3"
       CASE "W"
          DRAW "D2 BR1 D2 BR1 D3 U3 BR1 U2 D2 BR1 D3 U3 BR1 U2 BR1 U2 BR3"
       CASE "r"
          DRAW "BD3 D4 U4 R2 BR3 BU3"
       CASE " "
          DRAW "BR5"
       CASE "u"
          DRAW "BD3 D3 BR1 D1 R2 BU1 BR1 U3 BU3 BR3"
       CASE "p"
          DRAW "BD4 D5 U2 R3 U3 L2 BR6 BU4"
       CASE "S"
          DRAW "BR1 R3 L3 G1 D1 R3 F1 D2 G1 L3 BU7 BR6"

     END SELECT
     RETURN
do.buttons:
'button 1 x1,y1,x1+12,y1+10
    LINE (x1%, y1%)-(x1% + 12, y1% + 10), 1, BF
    LINE (x1% + 13, y1%)-(x1% + 13, y1% + 10), 0
    LINE (x1%, y1%)-(x1% + 12, y1%), 15
    LINE (x1%, y1% + 10)-(x1% + 12, y1% + 10), 0
    LINE (x1% + 3, y1% + 8)-(x1% + 9, y1% + 8), 0
   
'button 2 '513 238
    LINE (x1% + 15, y1%)-(x1% + 27, y1% + 10), 1, BF
    LINE (x1% + 28, y1%)-(x1% + 28, y1% + 10), 0
    LINE (x1% + 15, y1%)-(x1% + 27, y1%), 15
    LINE (x1% + 15, y1% + 10)-(x1% + 27, y1% + 10), 0
    LINE (x1% + 18, y1% + 2)-(x1% + 24, y1% + 8), 0, B
    FOR k = x1% + 19 TO x1% + 24 STEP 2
        PSET (k, y1% + 8), 1
        PSET (k + 1, y1% + 2), 1
    NEXT

'button 3 '513 238
    LINE (x1% + 30, y1%)-(x1% + 42, y1% + 10), 1, BF
    LINE (x1% + 43, y1%)-(x1% + 43, y1% + 10), 0
    LINE (x1% + 30, y1%)-(x1% + 42, y1%), 15
    LINE (x1% + 30, y1% + 10)-(x1% + 42, y1% + 10), 0
    LINE (x1% + 33, y1% + 2)-(x1% + 39, y1% + 8), 0
    LINE (x1% + 34, y1% + 2)-(x1% + 40, y1% + 8), 0
    LINE (x1% + 33, y1% + 8)-(x1% + 39, y1% + 2), 0
    LINE (x1% + 34, y1% + 8)-(x1% + 40, y1% + 2), 0
    RETURN

copy.box:
    LINE (80, 235)-(560, 251), 9, BF
    FOR k = 80 TO 560 - 16 STEP 2
         LINE (k, 235)-(k + 16, 251), 2'14
    NEXT k
   
    FOR k = 544 TO 560 STEP 2
        LINE (k, 235)-(k + (560 - k), 235 + 560 - k), 2'14
    NEXT k
   
    FOR k = 80 TO 95 STEP 2
        LINE (80, 251 + 80 - k)-(k, 251), 2
    NEXT k
   
    LINE (80, 252)-(560, 380), 1, BF
    LINE (100, 350)-(228, 370), 15, BF
    bmsg$ = "Copying files to: " + fpth$
    bmsg$ = UCASE$(bmsg$)
    DRAW "BM 228,240 C15"
    FOR kkk = 1 TO LEN(bmsg$)
        char$ = MID$(bmsg$, kkk, 1)
        GOSUB print.msg
    NEXT
        LINE (99, 336)-(230, 349), 0, B
        LINE (101, 338)-(229, 348), 1, BF
        LINE (101, 336)-(101, 348), 15
        DRAW "BM 104,340 C0"
        bmsg$ = "TASK IN PROGRESS"
        FOR kkk = 1 TO LEN(bmsg$)
            char$ = MID$(bmsg$, kkk, 1)
            GOSUB print.msg
        NEXT
   
    bmsg$ = "COPYING FILES"
    DRAW "BM 104,354 C0"
    FOR kkk = 1 TO LEN(bmsg$)
        char$ = MID$(bmsg$, kkk, 1)
        GOSUB print.msg
    NEXT

    bmsg$ = "File:"
    DRAW "BM 200,264 C0"
    FOR kkk = 1 TO LEN(bmsg$)
        char$ = MID$(bmsg$, kkk, 1)
        GOSUB seven.by.five
    NEXT
    IF amouse% THEN mouse 4, 0, MOUSEBUTTON, 320, 100

'BOX OUTLINE
    IF amouse% THEN mouse 4, 0, MOUSEBUTTON, 320, 100
    LINE (80, 235)-(560, 235), 15
    LINE (81, 236)-(559, 236), 0
    IF amouse% THEN mouse 4, 0, MOUSEBUTTON, 320, 100
    LINE (80, 235)-(80, 380), 15
    LINE (81, 236)-(81, 379), 0
    LINE (80, 380)-(560, 380), 0
    LINE (560, 235)-(560, 380), 0
'little boxes
'button 1,2,3
    x1% = 513: y1% = 238
    GOSUB do.buttons
   
    LINE (120, 287)-(519, 304), 15, BF
    DRAW "BM 102,292 C15"
    bmsg$ = "0%"
    FOR k = 1 TO LEN(bmsg$)
       char$ = MID$(bmsg$, k, 1)

        GOSUB print.msg
    NEXT
    DRAW "BM 530,292 C15"
    bmsg$ = "100%"
    FOR k = 1 TO LEN(bmsg$)
       char$ = MID$(bmsg$, k, 1)
       GOSUB print.msg
    NEXT
    '(80, 235)-(560, 251)
    icon16 "wumenu1.ico", 81, 264
    RETURN

check.hidden:
    IF hidden% THEN
        mouse MStatus, 0, MOUSEBUTTON, mouseX, mouseY
        IF MOUSEBUTTON THEN
            IF mouseX >= 320 AND mouseX <= 370 AND mouseY >= 453 AND mouseY <= 477 THEN
                hidden% = 0
                GOSUB copy.box
                mouse 4, 0, MOUSEB, 345, 436
                WHILE MOUSEBUTTON
                  mouse MStatus, 0, MOUSEBUTTON, mouseX, mouseY
                  mouse 4, 0, MOUSEB, 345, 436
                WEND
                mouse ShowCur, 0, MOUSEB, mouseX, mouseY
                LINE (290, 453)-(390, 476), 1, BF
            END IF
         ELSE
            bmsg$ = LTRIM$(STR$(pct%)) + "%"
            LINE (365, 462)-(380, 470), 1, BF
            DRAW "BM 365,462 C0"
            FOR k = 1 TO LEN(bmsg$)
               char$ = MID$(bmsg$, k, 1)
               'mouse MStatus, 0, MOUSEBUTTON, mouseX, mouseY
               GOSUB print.msg
            NEXT k
         END IF
    END IF
    RETURN

check.not.hidden:
    IF mouseX >= x1% AND mouseX <= x1% + 13 AND mouseY >= y1% AND mouseY <= y1% + 10 THEN
        hidden% = -1
        mouse 4, 0, MOUSEB, x1%, y1% - 20
        mouse ShowCur, 0, MOUSEB, mouseX, mouseY
'blank out copy box
        LINE (80, 235)-(560, 380), 3, BF

'setup taks bar box and message
        LINE (290, 453)-(390, 476), 0, B
        LINE (290, 453)-(390, 453), 15, B
        LINE (290, 453)-(290, 476), 15
        LINE (291, 475)-(389, 475), 0
        LINE (389, 454)-(389, 475), 0
        LINE (323, 456)-(387, 473), 1, BF
       
        DRAW "BM 323,462 C0"
        bmsg$ = "INSTALL" '"COPYING"
        FOR k = 1 TO LEN(bmsg$)
            char$ = MID$(bmsg$, k, 1)
            GOSUB print.msg
        NEXT k
        icon16 "wumenu1.ico", 293, 484
    END IF
    RETURN

SUB clearwindow (start.l%, col%, ecol%, lines%, clr%) STATIC
'SUB clearwindow (start.l%, col%, ecol%, lines%, clr%) STATIC
CLEAR.WINDOW:
SHARED regs AS regtype
SHARED clr1%, clr2%, clr3%, clr4%
'MinX = Col% + 1: MinY = Start.l% + 1
'MaxX = ecol% - 1: MaxY = Start.l% + lines%
    regs.ax = &H600
    clr& = clr%
    A& = clr& * 4096
    IF clr% > 7 THEN
        IF clr% = 8 THEN regs.bx = &H8000
        IF clr% = 9 THEN regs.bx = &H9000
        IF clr% = 10 THEN regs.bx = &HA000
        IF clr% = 11 THEN regs.bx = &HB000
        IF clr% = 12 THEN regs.bx = &HC000
        IF clr% = 13 THEN regs.bx = &HD000
        IF clr% = 14 THEN regs.bx = &HE000
        IF clr% = 15 THEN regs.bx = &HF000
    ELSE
        regs.bx = A&
    END IF
    regs.cx = ((start.l% + 1) * 256&) + col% + 1 - 257
    regs.dx = ((start.l% + lines%) * 256&) + ecol% - 1 - 257
    CALL interrupt(&H10, regs, regs)

END SUB

SUB colrprnt (TEXT$, Row%, col%, FC%, BC%) STATIC
REM Prints TEXT$ in EGA or VGA graphics mode with both Foreground and
' Background colours specified.  Doesn't work in graphics CGA modes.
' Achieves result by XORing text with a solid string of CHR$(219).
  SHARED INReg AS regtypeX, OUTReg AS regtypeX
  'Be sure to have regtypeX defined in main program (see QB.BI)
  C$ = STRING$(LEN(TEXT$), 219)       ' String of solid chars for backgrnd
  INReg.ax = &H1300             ' Video service 13h, subfunction 0
  INReg.bx = BC%                ' Background colour
  INReg.cx = LEN(TEXT$)         ' String length
  INReg.dx = 256 * (Row% - 1) + (col% - 1)      ' Text pos. in "origin 0"
  INReg.es = VARSEG(C$)           ' String's segment
  INReg.bp = SADD(C$)           ' String's address
  CALL INTERRUPTX(&H10, INReg, OUTReg)     ' Output the background
  INReg.bx = (FC% XOR BC%) + &H80   ' BL=ForeColor; BH=&H80 uses XOR to draw
  INReg.es = VARSEG(TEXT$)
  INReg.bp = SADD(TEXT$)
  CALL INTERRUPTX(&H10, INReg, OUTReg) ' Output the text, XORing w/backgrnd

END SUB

SUB icon16 (file$, xpos, ypos)
'SUB icon4 (file$, xpos, ypos)
    SHARED wdth AS INTEGER
    SHARED leng  AS INTEGER
    SHARED ega%
    'xpos = 0 '620
    'ypos = 31
    save.xpos = xpos ''0 '620     'xpos
    save.ypos = ypos ''31 'ypos
    oldypos = ypos ''31 'save.xpos' ypos
    oldxpos = xpos '''0 '620 'save.ypos 'xpos
    oldExpndWdth = oldxpos
    ExpndWdth = oldExpndWdth
    secicon = FREEFILE
    which$ = ""
  which$ = "V"
    aa% = -1

    OPEN file$ FOR BINARY AS secicon
                            'strip out some stuff I haven't figured out
    B$ = INPUT$(126, secicon)  'yet Must be the Palette stuff ?
    lent = LOF(secicon)
    leng = 32: wdth = 32
    FOR x = 1 TO leng * 16'512 '32 TO lent - 125
        B$ = INPUT$(1, secicon)
        yxy = ypos

        xpos = xpos + 1
    '    IF xpos = save.xpos + 1 THEN
    '        B$ = INPUT$(3, secicon)
    '        B$ = INPUT$(1, secicon)
    '    END IF

        ExpndWdth = ExpndWdth + 2
        clor1 = INT(ASC(B$) / 16)

        clor2 = ASC(B$) - (clor1 * 16)
        clr1% = 0: clr2% = 0
        IF UCASE$(which$) = "X" THEN '"C" THEN
            clr1% = clor1
                IF clr1% = 9 THEN
                    clr1% = 12
                ELSEIF clr1% = 1 THEN
                    clr1% = 4
                ELSEIF clr1% = 4 THEN
                    clr1% = 1
                ELSEIF clr1% = 12 THEN
                    clr1% = 9
          
                ELSEIF clr1% = 11 THEN
                    clr1% = 14
'                ELSEIF clr1% = 3 THEN
'                    clr1% = 6
                END IF

            IF (clor1 = 2) AND (clor2 = 2) THEN clr1% = 1: clr2% = 2: GOTO print.dot16  '2'0'3
            IF clor1 = 2 OR clor1 = 10 THEN clr1% = 1'2'0'3
            IF clor1 = 3 AND clor2 = 3 THEN
                clr1% = 1: clr2% = 0: GOTO print.dot16
            END IF
            IF clor1 = 3 OR clor1 = 11 THEN clr1% = 1
        
            IF clor1 = 4 AND clor2 = 4 THEN clr1% = 2: clr2% = 0
            IF clor1 = 4 OR clor1 = 12 THEN clr1% = 2'1
        
            IF clor1 = 5 OR clor1 = 13 THEN clr1% = 2'1'???
            IF clor1 = 6 THEN clr1% = 2
            IF clor1 = 14 THEN clr1% = 3'2
            IF clor1 = 7 THEN clr1% = 0: 'AND prior.clor = 15 THEN
            IF clor1 = 15 THEN clr1% = 3 '0
            IF clor1 = 8 THEN clr1% = 0'2
            IF clor1 = 9 THEN clr1% = 1
            'IF clor1 = 14 THEN clr1% = 3
        
            clr2% = clor2
                IF clr2% = 9 THEN
                    clr2% = 12
                ELSEIF clr2% = 1 THEN
                    clr2% = 4
                ELSEIF clr2% = 4 THEN
                    clr2% = 1
                ELSEIF clr2% = 12 THEN
                    clr2% = 9
         
                ELSEIF clr2% = 11 THEN
                    clr2% = 14
                ELSEIF clr2% = 3 THEN
                    clr2% = 6
                END IF
        
            IF clor2 = 2 OR clor2 = 10 THEN clr2% = 1'0'3
            IF clor2 = 3 OR clor2 = 11 THEN clr2% = 1'3'1
            IF clor2 = 4 OR clor2 = 12 THEN clr2% = 2'1
            IF clor2 = 5 OR clor2 = 13 THEN clr2% = 2'1'???
            IF clor2 = 6 THEN clr2% = 2 '1
            IF clor2 = 14 THEN clr2% = 3'2'1
            IF clor2 = 7 AND prior.clr2 <> 7 THEN '=15 THEN
                clr2% = 0
            ELSEIF clor2 = 7 THEN
                clr2% = 3
            END IF
            IF clor2 = 15 THEN clr2% = 3'0 ' 1
            IF clor2 = 8 THEN clr2% = 0'2
            IF clor2 = 9 THEN clr2% = 1
            'IF clor2 = 14 THEN clr2% = 3
            prior.clor = clor1
            prior.clr2 = clor2
        ELSE
            clr1% = clor1
            clr2% = clor2
                IF clr1% = 9 THEN
                    clr1% = 12
                ELSEIF clr1% = 1 THEN
                    clr1% = 4
                ELSEIF clr1% = 4 THEN
                    clr1% = 1
                ELSEIF clr1% = 12 THEN
                    clr1% = 9
           
                ELSEIF clr1% = 11 THEN
                    clr1% = 14
  '              ELSEIF clr1% = 3 THEN '??
  '                  clr1% = 6         '??
                ELSEIF clr1% = 14 THEN
                    clr1% = 11
  '              ELSEIF clr1% = 6 THEN
  '                  clr1% = 3
                END IF
            
                IF clr2% = 9 THEN
                    clr2% = 12
                ELSEIF clr2% = 1 THEN
                    clr2% = 4
                ELSEIF clr2% = 4 THEN
                    clr2% = 1
                ELSEIF clr2% = 12 THEN
                    clr2% = 9
          
                ELSEIF clr2% = 11 THEN
                    clr2% = 14
  '              ELSEIF clr2% = 3 THEN '??
  '                  clr2% = 6         '??
                ELSEIF clr2% = 14 THEN
                    clr2% = 11
  '              ELSEIF clr2% = 6 THEN
  '                  clr2% = 3
            
                END IF
         
        END IF
print.dot16:
'        IF xpos = oldxpos THEN
         IF xpos > save.xpos + 3 AND xpos < save.xpos + 13 AND ypos < save.ypos - 10 AND ypos > save.ypos - 29 THEN
            PSET (ExpndWdth, yxy), clr2%
            PSET ((ExpndWdth - 1), yxy), clr1%
        END IF
        IF xpos > oldxpos + (wdth / 2) - 1 THEN xpos = oldxpos: ExpndWdth = oldExpndWdth: ypos = ypos - 1
        'IF xpos > oldxpos + (wdth / 4) - 1 THEN x$ = INPUT$(8, secicon): xpos = oldxpos: ExpndWdth = oldExpndWdth: ypos = ypos - 1
    NEXT
    CLOSE secicon
    'WHILE INKEY$ = "": WEND

END SUB

SUB icon17 (file$, xpos, ypos, nocolor)
'SUB icon16
'SUB icon4 (file$, xpos, ypos)
    SHARED wdth AS INTEGER
    SHARED leng  AS INTEGER
    SHARED ega%
    'xpos = 0 '620
    'ypos = 31
    save.xpos = xpos ''0 '620     'xpos
    save.ypos = ypos ''31 'ypos
    oldypos = ypos ''31 'save.xpos' ypos
    oldxpos = xpos '''0 '620 'save.ypos 'xpos
    oldExpndWdth = oldxpos
    ExpndWdth = oldExpndWdth
    secicon = FREEFILE
    which$ = ""
  which$ = "V"
    aa% = -1

    OPEN file$ FOR BINARY AS secicon
                            'strip out some stuff I haven't figured out
    B$ = INPUT$(126, secicon)  'yet Must be the Palette stuff ?
    lent = LOF(secicon)
    leng = 32: wdth = 32
    FOR x = 1 TO leng * 16'512 '32 TO lent - 125
        B$ = INPUT$(1, secicon)
        yxy = ypos

        xpos = xpos + 1
    '    IF xpos = save.xpos + 1 THEN
    '        B$ = INPUT$(3, secicon)
    '        B$ = INPUT$(1, secicon)
    '    END IF

        ExpndWdth = ExpndWdth + 2
        clor1 = INT(ASC(B$) / 16)

        clor2 = ASC(B$) - (clor1 * 16)
        clr1% = 0: clr2% = 0
        IF UCASE$(which$) = "X" THEN '"C" THEN
            clr1% = clor1
                IF clr1% = 9 THEN
                    clr1% = 12
                ELSEIF clr1% = 1 THEN
                    clr1% = 4
                ELSEIF clr1% = 4 THEN
                    clr1% = 1
                ELSEIF clr1% = 12 THEN
                    clr1% = 9
         
                ELSEIF clr1% = 11 THEN
                    clr1% = 14
'                ELSEIF clr1% = 3 THEN
'                    clr1% = 6
                END IF

            IF (clor1 = 2) AND (clor2 = 2) THEN clr1% = 1: clr2% = 2: GOTO print.dot17  '2'0'3
            IF clor1 = 2 OR clor1 = 10 THEN clr1% = 1'2'0'3
            IF clor1 = 3 AND clor2 = 3 THEN
                clr1% = 1: clr2% = 0: GOTO print.dot17
            END IF
            IF clor1 = 3 OR clor1 = 11 THEN clr1% = 1
       
            IF clor1 = 4 AND clor2 = 4 THEN clr1% = 2: clr2% = 0
            IF clor1 = 4 OR clor1 = 12 THEN clr1% = 2'1
       
            IF clor1 = 5 OR clor1 = 13 THEN clr1% = 2'1'???
            IF clor1 = 6 THEN clr1% = 2
            IF clor1 = 14 THEN clr1% = 3'2
            IF clor1 = 7 THEN clr1% = 0: 'AND prior.clor = 15 THEN
            IF clor1 = 15 THEN clr1% = 3 '0
            IF clor1 = 8 THEN clr1% = 0'2
            IF clor1 = 9 THEN clr1% = 1
            'IF clor1 = 14 THEN clr1% = 3
       
            clr2% = clor2
                IF clr2% = 9 THEN
                    clr2% = 12
                ELSEIF clr2% = 1 THEN
                    clr2% = 4
                ELSEIF clr2% = 4 THEN
                    clr2% = 1
                ELSEIF clr2% = 12 THEN
                    clr2% = 9
        
                ELSEIF clr2% = 11 THEN
                    clr2% = 14
                ELSEIF clr2% = 3 THEN
                    clr2% = 6
                END IF
       
            IF clor2 = 2 OR clor2 = 10 THEN clr2% = 1'0'3
            IF clor2 = 3 OR clor2 = 11 THEN clr2% = 1'3'1
            IF clor2 = 4 OR clor2 = 12 THEN clr2% = 2'1
            IF clor2 = 5 OR clor2 = 13 THEN clr2% = 2'1'???
            IF clor2 = 6 THEN clr2% = 2 '1
            IF clor2 = 14 THEN clr2% = 3'2'1
            IF clor2 = 7 AND prior.clr2 <> 7 THEN '=15 THEN
                clr2% = 0
            ELSEIF clor2 = 7 THEN
                clr2% = 3
            END IF
            IF clor2 = 15 THEN clr2% = 3'0 ' 1
            IF clor2 = 8 THEN clr2% = 0'2
            IF clor2 = 9 THEN clr2% = 1
            'IF clor2 = 14 THEN clr2% = 3
            prior.clor = clor1
            prior.clr2 = clor2
        ELSE
            clr1% = clor1
            clr2% = clor2
                IF clr1% = 9 THEN
                    clr1% = 12
                ELSEIF clr1% = 1 THEN
                    clr1% = 4
                ELSEIF clr1% = 4 THEN
                    clr1% = 1
                ELSEIF clr1% = 12 THEN
                    clr1% = 9
          
                ELSEIF clr1% = 11 THEN
                    clr1% = 14
  '              ELSEIF clr1% = 3 THEN '??
  '                  clr1% = 6         '??
                ELSEIF clr1% = 14 THEN
                    clr1% = 11
  '              ELSEIF clr1% = 6 THEN
  '                  clr1% = 3
                END IF
           
                IF clr2% = 9 THEN
                    clr2% = 12
                ELSEIF clr2% = 1 THEN
                    clr2% = 4
                ELSEIF clr2% = 4 THEN
                    clr2% = 1
                ELSEIF clr2% = 12 THEN
                    clr2% = 9
         
                ELSEIF clr2% = 11 THEN
                    clr2% = 14
  '              ELSEIF clr2% = 3 THEN '??
  '                  clr2% = 6         '??
                ELSEIF clr2% = 14 THEN
                    clr2% = 11
  '              ELSEIF clr2% = 6 THEN
  '                  clr2% = 3
           
                END IF
        
        END IF
print.dot17:
'        IF xpos = oldxpos THEN
         IF xpos < save.xpos + 16 AND ypos < save.ypos - 16 THEN
            IF clr2% <> nocolor THEN PSET (ExpndWdth, yxy), clr2%
            IF clr1% <> nocolor THEN PSET ((ExpndWdth - 1), yxy), clr1%
        END IF
        IF xpos > oldxpos + (wdth / 2) - 1 THEN xpos = oldxpos: ExpndWdth = oldExpndWdth: ypos = ypos - 1
        'IF xpos > oldxpos + (wdth / 4) - 1 THEN x$ = INPUT$(8, secicon): xpos = oldxpos: ExpndWdth = oldExpndWdth: ypos = ypos - 1
    NEXT
    CLOSE secicon
    'WHILE INKEY$ = "": WEND


END SUB

SUB icon4 (file$, xpos, ypos)
'SUB icon4 (file$, xpos, ypos)
    SHARED wdth AS INTEGER
    SHARED leng  AS INTEGER
    SHARED ega%
    'xpos = 0 '620
    'ypos = 31
    save.xpos = xpos ''0 '620     'xpos
    save.ypos = ypos ''31 'ypos
    oldypos = ypos ''31 'save.xpos' ypos
    oldxpos = xpos '''0 '620 'save.ypos 'xpos
    'ypos = 31 ';save.ypos
    'xpos = 0 '620 'save.xpos
    oldExpndWdth = oldxpos
    ExpndWdth = oldExpndWdth
    secicon = FREEFILE
    which$ = ""
'    COLOR 0, 7: LOCATE 1, 1: PRINT SPACE$(80); : LOCATE 1, 1
'    PRINT "CGA or EGA/VGA display (C/E/V) ": LOCATE 1, 1
  which$ = "V"
'    WHILE INSTR(" CEV", UCASE$(which$)) < 2
'    which$ = INKEY$'LOCATE 1, 1: INPUT "CGA or EGA/VGA display (C/E) ", WHICH$
'    WEND
    'IF UCASE$(which$) = "E" THEN SCREEN 9'1 '9
    'IF UCASE$(which$) = "V" THEN SCREEN 12'1 '9
    'IF UCASE$(which$) = "C" THEN
    '    IF ega% THEN
    '        SCREEN 13'2'1: 'COLOR 8
    '    ELSE
    '        SCREEN 1
    '    END IF
    'END IF
    aa% = -1
 
    OPEN file$ FOR BINARY AS secicon
                            'strip out some stuff I haven't figured out
    B$ = INPUT$(126, secicon)  'yet Must be the Palette stuff ?
    lent = LOF(secicon)
    leng = 32: wdth = 32
    'IF UCASE$(which$) = "E" THEN SCREEN 9'1 '9
    'IF UCASE$(which$) = "V" THEN SCREEN 12'1 '9
    'IF UCASE$(which$) = "C" THEN
    '    IF ega% THEN
    '        SCREEN 13'2'1: 'COLOR 8
    '    ELSE
    '        SCREEN 1
    '    END IF
    'END IF
 
    'LOCATE 1, 2: PRINT "Icon Mode 4 - "; UCASE$(which$); "GA"
    'LOCATE 2, 2: PRINT file$
    'IF UCASE$(which$) = "V" OR UCASE$(which$) = "E" OR UCASE$(which$) = "C" THEN
    '    LINE (2, 35)-(246, 165), 15, BF
    '    clr% = 7
    '    LINE (8, 40)-(13, 160), clr%, BF
    '    LINE (8 + 226, 40)-(13 + 226, 160), clr%, BF
    '    LINE (7, 40)-(7, 160), 0
    '    'top black line
    '    LINE (14, 47)-(14, 153), 0
    '    'right side black line
    '    LINE (233, 47)-(233, 153), 0
    '    clr% = 7
    '
     '   'UPPER HORIZ GRAY BAR
     '   LINE (14, 41)-(234, 46), clr%, BF
     '
     '   'LOWER HORIZ GRAY BAR
     '   LINE (14, 41 + 113)-(234, 46 + 113), clr%, BF
     '
     '   'BLACK LINES HORIZONTAL
     '   LINE (14, 47)-(233, 47), 0
     '   LINE (14, 153)-(233, 153), 0
     '   LINE (7, 40)-(240, 40), 0
     '   LINE (7, 160)-(240, 160), 0
     '   LINE (8, 140)-(13, 140), 0
     '   LINE (233, 140)-(240, 140), 0
     '
     '   'BLACK DIVIDING BARS
     '   LINE (26, 154)-(26, 160), 0
     '   LINE (219, 154)-(219, 160), 0
     '   LINE (240, 40)-(240, 160), 0
     '   LINE (8, 61)-(13, 61), 0
     '   LINE (233, 61)-(240, 61), 0
     '   LINE (219, 41)-(219, 46), 0
     '   LINE (26, 41)-(26, 46), 0
     '
     '   'GRAY BOXES
     '   LINE (220, 47)-(232, 60), 7, BF
     '   LINE (25, 47)-(232, 47), 0
     '   LINE (25, 61)-(232, 61), 0
     '
     '   'BLUE RECTANGLE FOR 'ICONS'
     '   LINE (27, 48)-(219, 60), 1, BF
     '   'THIS SIMPLY LOCATES
     '   LINE (25, 47)-(25, 47), 1
     '
     '   DRAW "C0"             'Set color to BLACK
     '  'DRAW BORDER
     '   DRAW "BD5 BR30"
     '
     '   DRAW "C15" 'COLOR BRIGHT WHITE
     '   DRAW "BR50"   'MOVE TO RIGHT
     '
     '   DRAW "BR3" 'SOME MORE
     '   DRAW "BR1 D5 U5 BL1" 'I'
     '
     '   DRAW "BR4" 'MOVE TO RIGHT
     '   DRAW "R3 L3 D5 R3 BU5"   'C'
REM -- O
     '   DRAW "BR4" 'MOVE
     '   DRAW "D5 R3 U5 L3 R3" 'O'
REM --N
     '   DRAW "BR4"               'MOVE
     '   DRAW "D5 U5 F5 U5"  'N'
REM -- S
     '   DRAW "BR4"  'MOVE
     '   DRAW "R2 L2 D2 R2 D3 L2 BU5" 'S'
     '
REM -- LOCATE CURSOR TO LEFT OF BLUE BLOCK
     
     '  DRAW "C0"  'COLOR BLACK
     '  DRAW "BM226,52 F3 L6 E3 "   'Draw a triangle.
     '
     '  DRAW "BD2"  'MOVE INTO TRIANGLE
     '
     '  DRAW "P0,0" 'PAINT IT ALL BLACK
     '  'GRAY SQUARE FOR - SIGN
     '  LINE (15, 48)-(26, 61), 7, BF
     '
     '  LINE (18, 54)-(22, 54), 15     'MINUS SIGN BRIGHT WHITE
     '  LINE (14, 47)-(26, 61), 0, B 'OUTLINE LEFT GRAY BOX
     '  'outline minus sign
     '  LINE (17, 53)-(23, 55), 0, B
     '  'highlight 3d right gray box with triangle
     '   LINE (220, 47)-(232, 47), 15
     '   LINE (220, 47)-(220, 60), 15
     '   FOR x = 220 TO 232
     '       IF x / 2 = INT(x / 2) THEN clrx1% = 7: clrx2% = 8 ELSE clrx1% = 8: clrx2% = 7
     '   LINE (x, 60)-(x, 60), clrx1%
     '   IF x < 232 THEN LINE (x + 1, 59)-(x + 1, 59), clrx1%
     '   NEXT x
    'END IF
    FOR x = 1 TO leng * 16'512 '32 TO lent - 125
        B$ = INPUT$(1, secicon)
        yxy = ypos
 
        xpos = xpos + 1
        ExpndWdth = ExpndWdth + 2
        clor1 = INT(ASC(B$) / 16)
 
        clor2 = ASC(B$) - (clor1 * 16)
        clr1% = 0: clr2% = 0
        IF UCASE$(which$) = "X" THEN '"C" THEN
            clr1% = clor1
                IF clr1% = 9 THEN
                    clr1% = 12
                ELSEIF clr1% = 1 THEN
                    clr1% = 4
                ELSEIF clr1% = 4 THEN
                    clr1% = 1
                ELSEIF clr1% = 12 THEN
                    clr1% = 9
           
                ELSEIF clr1% = 11 THEN
                    clr1% = 14
'                ELSEIF clr1% = 3 THEN
'                    clr1% = 6
                END IF

            IF (clor1 = 2) AND (clor2 = 2) THEN clr1% = 1: clr2% = 2: GOTO print.dot  '2'0'3
            IF clor1 = 2 OR clor1 = 10 THEN clr1% = 1'2'0'3
            IF clor1 = 3 AND clor2 = 3 THEN
                clr1% = 1: clr2% = 0: GOTO print.dot
            END IF
            IF clor1 = 3 OR clor1 = 11 THEN clr1% = 1
         
            IF clor1 = 4 AND clor2 = 4 THEN clr1% = 2: clr2% = 0
            IF clor1 = 4 OR clor1 = 12 THEN clr1% = 2'1
         
            IF clor1 = 5 OR clor1 = 13 THEN clr1% = 2'1'???
            IF clor1 = 6 THEN clr1% = 2
            IF clor1 = 14 THEN clr1% = 3'2
            IF clor1 = 7 THEN clr1% = 0: 'AND prior.clor = 15 THEN
            IF clor1 = 15 THEN clr1% = 3 '0
            IF clor1 = 8 THEN clr1% = 0'2
            IF clor1 = 9 THEN clr1% = 1
            'IF clor1 = 14 THEN clr1% = 3
         
            clr2% = clor2
                IF clr2% = 9 THEN
                    clr2% = 12
                ELSEIF clr2% = 1 THEN
                    clr2% = 4
                ELSEIF clr2% = 4 THEN
                    clr2% = 1
                ELSEIF clr2% = 12 THEN
                    clr2% = 9
          
                ELSEIF clr2% = 11 THEN
                    clr2% = 14
                ELSEIF clr2% = 3 THEN
                    clr2% = 6
                END IF
         
            IF clor2 = 2 OR clor2 = 10 THEN clr2% = 1'0'3
            IF clor2 = 3 OR clor2 = 11 THEN clr2% = 1'3'1
            IF clor2 = 4 OR clor2 = 12 THEN clr2% = 2'1
            IF clor2 = 5 OR clor2 = 13 THEN clr2% = 2'1'???
            IF clor2 = 6 THEN clr2% = 2 '1
            IF clor2 = 14 THEN clr2% = 3'2'1
            IF clor2 = 7 AND prior.clr2 <> 7 THEN '=15 THEN
                clr2% = 0
            ELSEIF clor2 = 7 THEN
                clr2% = 3
            END IF
            IF clor2 = 15 THEN clr2% = 3'0 ' 1
            IF clor2 = 8 THEN clr2% = 0'2
            IF clor2 = 9 THEN clr2% = 1
            'IF clor2 = 14 THEN clr2% = 3
            prior.clor = clor1
            prior.clr2 = clor2
        ELSE
            clr1% = clor1
            clr2% = clor2
                IF clr1% = 9 THEN
                    clr1% = 12
                ELSEIF clr1% = 1 THEN
                    clr1% = 4
                ELSEIF clr1% = 4 THEN
                    clr1% = 1
                ELSEIF clr1% = 12 THEN
                    clr1% = 9
            
                ELSEIF clr1% = 11 THEN
                    clr1% = 14
  '              ELSEIF clr1% = 3 THEN '??
  '                  clr1% = 6         '??
                ELSEIF clr1% = 14 THEN
                    clr1% = 11
  '              ELSEIF clr1% = 6 THEN
  '                  clr1% = 3
                END IF
             
                IF clr2% = 9 THEN
                    clr2% = 12
                ELSEIF clr2% = 1 THEN
                    clr2% = 4
                ELSEIF clr2% = 4 THEN
                    clr2% = 1
                ELSEIF clr2% = 12 THEN
                    clr2% = 9
           
                ELSEIF clr2% = 11 THEN
                    clr2% = 14
  '              ELSEIF clr2% = 3 THEN '??
  '                  clr2% = 6         '??
                ELSEIF clr2% = 14 THEN
                    clr2% = 11
  '              ELSEIF clr2% = 6 THEN
  '                  clr2% = 3
             
                END IF
          
        END IF
print.dot:
'        IF xpos = oldxpos THEN
            PSET (ExpndWdth, yxy), clr2%
            PSET ((ExpndWdth - 1), yxy), clr1%
'        END IF
        IF xpos > oldxpos + (wdth / 2) - 1 THEN xpos = oldxpos: ExpndWdth = oldExpndWdth: ypos = ypos - 1
    NEXT
    CLOSE secicon
    'WHILE INKEY$ = "": WEND

END SUB

SUB icon5 (file$, xpos, ypos)
'SUB icon4 (file$, xpos, ypos)
    SHARED wdth AS INTEGER
    SHARED leng  AS INTEGER
    SHARED ega%
   ' xpos = 100 '620
   ' ypos = 62
    save.xpos = xpos
    save.ypos = ypos
    oldypos = ypos
    oldxpos = xpos '100 '620 'save.ypos 'xpos
    ypos = ypos'62 ';save.ypos
    xpos = save.xpos'100 '620 'save.xpos
    oldExpndWdth = oldxpos
    ExpndWdth = oldExpndWdth
    secicon = FREEFILE
    which$ = ""
  which$ = "V"
    aa% = -1

    OPEN file$ FOR BINARY AS secicon
                            'strip out some stuff I haven't figured out
    B$ = INPUT$(126, secicon)  'yet Must be the Palette stuff ?
    lent = LOF(secicon)
    leng = 64: wdth = 64

    FOR x = 1 TO leng * 8 '16'512 '32 TO lent - 125
        B$ = INPUT$(1, secicon)
        yxy = ypos

        xpos = xpos + 2
        ExpndWdth = ExpndWdth + 4
        clor1 = INT(ASC(B$) / 16)

        clor2 = ASC(B$) - (clor1 * 16)
        clr1% = 0: clr2% = 0
        IF UCASE$(which$) = "X" THEN '"C" THEN
            clr1% = clor1
                IF clr1% = 9 THEN
                    clr1% = 12
                ELSEIF clr1% = 1 THEN
                    clr1% = 4
                ELSEIF clr1% = 4 THEN
                    clr1% = 1
                ELSEIF clr1% = 12 THEN
                    clr1% = 9
          
                ELSEIF clr1% = 11 THEN
                    clr1% = 14
                END IF

            IF (clor1 = 2) AND (clor2 = 2) THEN clr1% = 1: clr2% = 2: GOTO print.dot2  '2'0'3
            IF clor1 = 2 OR clor1 = 10 THEN clr1% = 1'2'0'3
            IF clor1 = 3 AND clor2 = 3 THEN
                clr1% = 1: clr2% = 0: GOTO print.dot2
            END IF
            IF clor1 = 3 OR clor1 = 11 THEN clr1% = 1
        
            IF clor1 = 4 AND clor2 = 4 THEN clr1% = 2: clr2% = 0
            IF clor1 = 4 OR clor1 = 12 THEN clr1% = 2'1
        
            IF clor1 = 5 OR clor1 = 13 THEN clr1% = 2'1'???
            IF clor1 = 6 THEN clr1% = 2
            IF clor1 = 14 THEN clr1% = 3'2
            IF clor1 = 7 THEN clr1% = 0: 'AND prior.clor = 15 THEN
            IF clor1 = 15 THEN clr1% = 3 '0
            IF clor1 = 8 THEN clr1% = 0'2
            IF clor1 = 9 THEN clr1% = 1
        
            clr2% = clor2
                IF clr2% = 9 THEN
                    clr2% = 12
                ELSEIF clr2% = 1 THEN
                    clr2% = 4
                ELSEIF clr2% = 4 THEN
                    clr2% = 1
                ELSEIF clr2% = 12 THEN
                    clr2% = 9
         
                ELSEIF clr2% = 11 THEN
                    clr2% = 14
                ELSEIF clr2% = 3 THEN
                    clr2% = 6
                END IF
        
            IF clor2 = 2 OR clor2 = 10 THEN clr2% = 1'0'3
            IF clor2 = 3 OR clor2 = 11 THEN clr2% = 1'3'1
            IF clor2 = 4 OR clor2 = 12 THEN clr2% = 2'1
            IF clor2 = 5 OR clor2 = 13 THEN clr2% = 2'1'???
            IF clor2 = 6 THEN clr2% = 2 '1
            IF clor2 = 14 THEN clr2% = 3'2'1
            IF clor2 = 7 AND prior.clr2 <> 7 THEN '=15 THEN
                clr2% = 0
            ELSEIF clor2 = 7 THEN
                clr2% = 3
            END IF
            IF clor2 = 15 THEN clr2% = 3'0 ' 1
            IF clor2 = 8 THEN clr2% = 0'2
            IF clor2 = 9 THEN clr2% = 1
            prior.clor = clor1
            prior.clr2 = clor2
        ELSE
            clr1% = clor1
            clr2% = clor2
                IF clr1% = 9 THEN
                    clr1% = 12
                ELSEIF clr1% = 1 THEN
                    clr1% = 4
                ELSEIF clr1% = 4 THEN
                    clr1% = 1
                ELSEIF clr1% = 12 THEN
                    clr1% = 9
           
                ELSEIF clr1% = 11 THEN
                    clr1% = 14
                ELSEIF clr1% = 14 THEN
                    clr1% = 11
                END IF
            
                IF clr2% = 9 THEN
                    clr2% = 12
                ELSEIF clr2% = 1 THEN
                    clr2% = 4
                ELSEIF clr2% = 4 THEN
                    clr2% = 1
                ELSEIF clr2% = 12 THEN
                    clr2% = 9
          
                ELSEIF clr2% = 11 THEN
                    clr2% = 14
                ELSEIF clr2% = 14 THEN
                    clr2% = 11
            
                END IF
         
        END IF
print.dot2:
            PSET (ExpndWdth, yxy), clr2%
            PSET (ExpndWdth + 1, yxy), clr2%
            PSET ((ExpndWdth - 1), yxy), clr1%
            PSET ((ExpndWdth - 2), yxy), clr1%
           
            PSET (ExpndWdth, yxy + 1), clr2%
            PSET (ExpndWdth + 1, yxy + 1), clr2%
            PSET ((ExpndWdth - 1), yxy + 1), clr1%
            PSET ((ExpndWdth - 2), yxy + 1), clr1%
       
        IF xpos > oldxpos + (wdth / 2) - 1 THEN xpos = oldxpos: ExpndWdth = oldExpndWdth: ypos = ypos - 2
    NEXT
    CLOSE secicon

END SUB

SUB mouse (Funcode, result, P2, p3, p4)
'SUB mouse (Funcode, result, P2, p3, p4)
SHARED regs AS regtype
    regs.ax = Funcode
    regs.bx = P2
    sav.p3 = p3: sav.p4 = p4
    regs.cx = p3
    regs.dx = p4
    CALL interrupt(&H33, regs, regs)
    result = regs.ax
    P2 = regs.bx
    p3 = regs.cx
    p4 = regs.dx
    ''IF sav.p3 = 54 AND sav.p4 = 1 THEN p3 = 54 * 8: p4 = 8
'INT 33 - MS MOUSE - DEFINE TEXT CURSOR
'        AX = 000Ah
'        BX = hardware/software text cursor
'            0000h software
'                CX = screen mask
'                DX = cursor mask
'            0001h hardware
'                CX = start scan line
'                DX = end scan line
'Note:   when the software cursor is selected, the char/attribute data at the
'          current screen position is ANDed with the screen mask and then XORed
'          with the cursor mask
'SeeAlso: AX=0009h

END SUB
